/*  DTN's Super SmartCar FC-51 Rear Obstacle Detection IR Sensors Test and Calibration Program 
 *         Available at http://devestechnet.com/NewTech/SuperSmartCar#ArduinoSoftware 
 *           This program is designed for 3 FC-51's spaced 35 degrees apart at the 
 *                            rear of the DTN SuperSmartCar. 
 *                Distance 2 - 30cm or 3/4" to 11-3/4" Detection Range
 *                Digital Output Signal (High or Low Only) 
 *                Detection Angle: 35 Degrees */

/*                Adjustable detection distance range via potentiometer: 
 *                      Clockwise: Increase detection distance 
 *                      Counter-clockwise: Reduce detection distance 
 *        If the obstacle light on the sensor stays on, you have adjusted too far. 

                       Open Serial Monitor to view Sensor Output */

const int rearRightSensor = 30;                      /* Sensor output to Arduino Digital Pin 30 */
const int rearMiddleSensor = 31;                     /* Sensor output to Arduino Digital Pin 31 */
const int rearLeftSensor = 32;                       /* Sensor output to Arduino Digital Pin 32 */

int rearLeftDetect = HIGH;
int rearMiddleDetect = HIGH;                                          /* HIGH means NO OBSTACLE */
int rearRightDetect = HIGH;

void setup() {
  Serial.begin(115200);
  pinMode(rearRightSensor, INPUT);
  pinMode(rearMiddleSensor, INPUT);
  pinMode(rearLeftSensor, INPUT);
}

void loop() {
  rearRightDetect = digitalRead(rearRightSensor);
  rearMiddleDetect = digitalRead(rearMiddleSensor);
  rearLeftDetect = digitalRead(rearLeftSensor);

  if (rearRightDetect == LOW && rearMiddleDetect == HIGH && rearLeftDetect == HIGH) {
    Serial.print(" Obstacle Detected at the Right Rear!\n");
  }
  else if (rearRightDetect == HIGH && rearMiddleDetect == LOW && rearLeftDetect == HIGH) {
    Serial.print(" Obstacle Detected at the Center Rear!\n");
  }
  else if (rearRightDetect == HIGH && rearMiddleDetect == HIGH && rearLeftDetect == LOW) {
    Serial.print(" Obstacle Detected at the Left Rear!\n");
  }
  else if (rearRightDetect == LOW && rearMiddleDetect == LOW && rearLeftDetect == HIGH) {
    Serial.print(" Obstacle Detected at both the Right and Center Rear!\n");
  }
  else if (rearRightDetect == HIGH && rearMiddleDetect == LOW && rearLeftDetect == LOW) {
    Serial.print(" Obstacle Detected at both the Left and Center Rear!\n");
  }
  else if (rearRightDetect == LOW && rearMiddleDetect == LOW && rearLeftDetect == LOW) {
    Serial.print(" Obstacle Detected at all three Rear Sensors!\n");
  }
  else {
    Serial.print(" Rear of the Vehicle is Clear of all Obstacles!\n");
  }
  delay (100);
}


